package net.universe_factory.minecraft.test;

import java.util.ArrayList;

import net.minecraft.item.Item;
import net.minecraft.item.ItemFood;
import net.minecraft.item.ItemStack;
import net.minecraft.world.World;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.event.terraingen.BiomeEvent.CreateDecorator;
import net.universe_factory.minecraft.test.generic.GenericWood;
import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.Mod.EventHandler;
import cpw.mods.fml.common.Mod.Instance;
import cpw.mods.fml.common.event.FMLInitializationEvent;
import cpw.mods.fml.common.eventhandler.SubscribeEvent;
import cpw.mods.fml.common.registry.GameRegistry;

@Mod(modid = Test.MODID, version = Test.VERSION)
public class Test {
	public static final String MODID = "neoraider_test";
	public static final String VERSION = "1";

	@Instance(value = MODID)
	public static Test instance;

	public static final Item cherries = new ItemFood(2, 0.2f, false).setTextureName(MODID + ":cherries").setUnlocalizedName("cherries");
	public static final GenericWood cherryTree = new GenericWood() {
		@Override
		public String getName() {
			return "Cherry";
		}

		@Override
		public int getMinTreeHeight() {
			return 4;
		}

		@Override
		public ArrayList<ItemStack> getDrops(World world, int x, int y, int z, int meta, int fortune) {
			ArrayList<ItemStack> ret = new ArrayList<ItemStack>();

			int chance = 30;

			if (fortune > 0) {
				chance -= 2 << fortune;

				if (chance < 5)
					chance = 5;
			}

			if (world.rand.nextInt(chance) == 0)
				ret.add(new ItemStack(cherries, 1));

			return ret;
		}
	};

	@EventHandler
	public void preInit(FMLInitializationEvent event) {
		MinecraftForge.TERRAIN_GEN_BUS.register(new TerrainGenHandler());

		GameRegistry.registerItem(cherries, "cherries");

		cherryTree.register();
	}

	public class TerrainGenHandler {
		@SubscribeEvent
		public void handleCreateDecorator(CreateDecorator event) {
			event.newBiomeDecorator = new TestBiomeDecorator(cherryTree);

			event.newBiomeDecorator.bigMushroomsPerChunk = event.originalBiomeDecorator.bigMushroomsPerChunk;
			event.newBiomeDecorator.cactiPerChunk = event.originalBiomeDecorator.cactiPerChunk;
			event.newBiomeDecorator.clayPerChunk = event.originalBiomeDecorator.clayPerChunk;
			event.newBiomeDecorator.deadBushPerChunk = event.originalBiomeDecorator.deadBushPerChunk;
			event.newBiomeDecorator.flowersPerChunk = event.originalBiomeDecorator.flowersPerChunk;
			event.newBiomeDecorator.generateLakes = event.originalBiomeDecorator.generateLakes;
			event.newBiomeDecorator.grassPerChunk = event.originalBiomeDecorator.grassPerChunk;
			event.newBiomeDecorator.mushroomsPerChunk = event.originalBiomeDecorator.mushroomsPerChunk;
			event.newBiomeDecorator.reedsPerChunk = event.originalBiomeDecorator.reedsPerChunk;
			event.newBiomeDecorator.sandPerChunk = event.originalBiomeDecorator.sandPerChunk;
			event.newBiomeDecorator.sandPerChunk2 = event.originalBiomeDecorator.sandPerChunk2;
			event.newBiomeDecorator.treesPerChunk = event.originalBiomeDecorator.treesPerChunk;
			event.newBiomeDecorator.waterlilyPerChunk = event.originalBiomeDecorator.waterlilyPerChunk;
		}
	}
}
